Bug 2050825 - linux-firmware: Size reduction by eliding versions not used by the kernel
Summary: linux-firmware: Size reduction by eliding versions not used by the kernel
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: linux-firmware
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: David Woodhouse
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2022-02-04 17:46 UTC by Florian Weimer
Modified: 2022-06-30 02:17 UTC (History)
6 users (show)

Fixed In Version: linux-firmware-20220610-135.fc36 linux-firmware-20220610-135.fc35
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-06-16 01:21:04 UTC
Type: Bug


Attachments (Terms of Use)

Description Florian Weimer 2022-02-04 17:46:15 UTC
I noticed this during boot (5.15.17-200.fc35.x86_64):

[    2.986721] iwlwifi 0000:03:00.0: Direct firmware load for iwlwifi-cc-a0-66.ucode failed with error -2
[    2.986746] iwlwifi 0000:03:00.0: Direct firmware load for iwlwifi-cc-a0-65.ucode failed with error -2
[    2.986764] iwlwifi 0000:03:00.0: Direct firmware load for iwlwifi-cc-a0-64.ucode failed with error -2
[    3.018280] iwlwifi 0000:03:00.0: loaded firmware version 63.c04f3485.0 cc-a0-63.ucode op_mode iwlmvm

However, iwlax2xx-firmware-20211216-127.fc35.noarch contains:

448K /lib/firmware/iwlwifi-cc-a0-67.ucode.xz
440K /lib/firmware/iwlwifi-cc-a0-63.ucode.xz
436K /lib/firmware/iwlwifi-cc-a0-62.ucode.xz
432K /lib/firmware/iwlwifi-cc-a0-59.ucode.xz
420K /lib/firmware/iwlwifi-cc-a0-55.ucode.xz
420K /lib/firmware/iwlwifi-cc-a0-53.ucode.xz
384K /lib/firmware/iwlwifi-cc-a0-50.ucode.xz
380K /lib/firmware/iwlwifi-cc-a0-48.ucode.xz
376K /lib/firmware/iwlwifi-cc-a0-46.ucode.xz

Looking at the current kernel sources, it seems that drivers/net/wireless/intel/iwlwifi/cfg/22000.c will never load any of the files having versions prior to -63.

This pattern seems to be quite common across the iwlwifi drivers, although for some devices, the selection logic is much more complicated, with card-specific maximum and minimum versions.

Comment 1 Peter Robinson 2022-06-14 08:54:41 UTC
So I went through and removed all the ones upstream not supported by any stable kernels, about 27mb worth, upstream so this will be resolved in the next release. There will be possibly more to do but I'm not going to track it here.

Comment 2 Florian Weimer 2022-06-14 08:56:45 UTC
Much appreciated, thanks!

Comment 3 Fedora Update System 2022-06-14 09:02:48 UTC
FEDORA-2022-ee69e90000 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2022-ee69e90000

Comment 4 Fedora Update System 2022-06-14 09:02:51 UTC
FEDORA-2022-0566172ae3 has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2022-0566172ae3

Comment 5 Fedora Update System 2022-06-15 01:11:21 UTC
FEDORA-2022-0566172ae3 has been pushed to the Fedora 36 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2022-0566172ae3`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-0566172ae3

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 6 Fedora Update System 2022-06-15 01:15:35 UTC
FEDORA-2022-ee69e90000 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2022-ee69e90000`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-ee69e90000

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 7 Fedora Update System 2022-06-16 01:21:04 UTC
FEDORA-2022-0566172ae3 has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 8 Fedora Update System 2022-06-30 02:17:17 UTC
FEDORA-2022-ee69e90000 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.